/** Rill v0.0.557 https://www.npmjs.com/package/rill License: MIT*/
var GeneratorFunction, noop;

noop = function*() {
  return;
};

GeneratorFunction = noop.constructor;


/*
 * Compose `middleware` returning
 * a fully valid middleware comprised
 * of all those which are passed.
#
 * @param {Array} middleware
 * @return {Function}
 * @api private
 */

module.exports = function(middleware) {
  if (middleware instanceof GeneratorFunction) {
    return middleware;
  }
  return function*(req, res, next) {
    var i;
    i = middleware.length;
    if (next == null) {
      next = noop;
    }
    while (i--) {
      next = middleware[i].call(this, req, res, next);
    }
    return (yield* next);
  };
};
