noop = -> yield return
GeneratorFunction = noop.constructor


###
# Compose `middleware` returning
# a fully valid middleware comprised
# of all those which are passed.
#
# @param {Array} middleware
# @return {Function}
# @api private
###
module.exports = (middleware)->
	return middleware if middleware instanceof GeneratorFunction

	(req, res, next)->
		i     = middleware.length
		next ?= noop
		next  = middleware[i].call(@, req, res, next) while i--
		return yield from next